//=============================================================================////                                 D.S. de Structures de Donnees - 01/04/1998//                                 parcours dans un graphe sans circuit (DAG)//// A.F. Mouyart////      date de creation : 07/04/1998// derniere modification : 08/04/1998//// compilateur : Symantec C++ for Macintosh 7.0////=============================================================================//                                                      inclusion de fichiers#include <iostream.h>#include <fstream.h>#include "bibli.h"#include "listes.h"#include "piles.h"#include "files.h"//=============================================================================//                                                        definition de types#define MAX 50typedef ELEMENT SOMMET;typedef char NOM[20];typedef LISTE ENSEMBLE;typedef LISTE DAG[MAX];//=============================================================================//                                                    prototypes de fonctionsLISTE les_successeurs(SOMMET);void construire_graphe(DAG);void parcours_profondeur_recursif(SOMMET);void parcours_profondeur_liste(LISTE);void parcours_profondeur_iteratif(SOMMET);void parcours_largeur(SOMMET);void tri_topologique_recursif(SOMMET);void tri_topologique_liste(LISTE);void tri_topologique_iteratif(SOMMET);//=============================================================================//                                        declarations de variables globales   ifstream sommets ("sommets.dat",ios::in );   ifstream graphe  ( "graphe.dat",ios::in );   ofstream fout    ("affiche.dat",ios::out);   ENSEMBLE E = VIDE;   int N;   DAG G;   NOM nom_du_sommet[MAX];//=============================================================================//                                                        fonction principalevoid main(void){   SOMMET depart = 0;   construire_graphe(G);      cout << endl << "parcours en profondeur recursif" << endl << endl;   fout << endl << "parcours en profondeur recursif" << endl << endl;   parcours_profondeur_recursif(depart);   attendre();   cout << endl << "parcours en profondeur iteratif" << endl << endl;   fout << endl << "parcours en profondeur iteratif" << endl << endl;   parcours_profondeur_iteratif(depart);   attendre();   cout << endl << "parcours en largeur" << endl << endl;   fout << endl << "parcours en largeur" << endl << endl;   parcours_largeur(depart);   attendre();   cout << endl << "tri topologique recursif" << endl << endl;   fout << endl << "tri topologique recursif" << endl << endl;   tri_topologique_recursif(depart);   attendre();   cout << endl << "tri topologique iteratif" << endl << endl;   fout << endl << "tri topologique iteratif" << endl << endl;   tri_topologique_iteratif(depart);   attendre();}//=============================================================================//                                                   definitions de fonctionsvoid construire_graphe(DAG G){   int i;   SOMMET x;      sommets >> N;   for(i=0;i<N;i++)   {      sommets >> nom_du_sommet[i];      init_liste(G[i]);      do      {         graphe >> x;         if (x>=0) G[i] = ajout_a_la_fin(x,G[i]);      } while (x>=0);   }}LISTE les_successeurs(SOMMET x){   return G[x];}// ---------------------------------- parcours en profondeur (prefixe)void parcours_profondeur_recursif(SOMMET depart){   // on admet que certains noeuds puissent etre affiches plusieurs fois      cout << depart << " " << nom_du_sommet[depart] << endl;   fout << depart << " " << nom_du_sommet[depart] << endl;   parcours_profondeur_liste(les_successeurs(depart));}void parcours_profondeur_liste(LISTE L){   if (!est_une_liste_vide(L))   {      parcours_profondeur_recursif(tete(L));      parcours_profondeur_liste(reste(L));   }}void parcours_profondeur_iteratif(SOMMET depart){   // chaque noeud ne doit etre affiche qu'une seule fois      PILE P;   ENSEMBLE E;             // noeuds deja affiches   LISTE L;   BOOLEEN possible;   SOMMET x;      init_pile(P); empiler(depart,P);   init_ensemble(E); ajouter(depart,E);   cout << depart << " " << nom_du_sommet[depart] << endl;   fout << depart << " " << nom_du_sommet[depart] << endl;      while (!est_une_pile_vide(P))   {         // choisir, si c'est possible, un noeud qui soit,         // d'une part, successeur du noeud au sommet de la pile,         // et qui, d'autre part, n'appartienne pas         // a l'ensemble des noeuds deja affiches         // afficher ce noeud, l'empiler et l'ajouter a l'ensemble         // si ce n'est pas possible : depiler               possible = FAUX;      L = les_successeurs(sommet(P));      while (!est_une_liste_vide(L) && !possible)      {         x = tete(L);         if (!appartient(x,E))         {            cout << x << " " << nom_du_sommet[x] << endl;            fout << x << " " << nom_du_sommet[x] << endl;            empiler(x,P);            ajouter(x,E);            possible = VRAI;         }         else L = reste(L);      }      if (!possible) depiler(x,P);   }}// ---------------------------------- parcours en largeur (par niveaux)void parcours_largeur(SOMMET depart){   // on admet que certains noeuds puissent etre affiches plusieurs fois      FILE F;   LISTE L;   SOMMET x,y;      init_file(F);   cout << depart << " " << nom_du_sommet[depart] << endl;   fout << depart << " " << nom_du_sommet[depart] << endl;   entrer(depart,F);   while (!est_une_file_vide(F))   {         // supprimer un noeud de la file d'attente,         // l'afficher,         // ajouter a la file chacun de ses successeurs               sortir(x,F);      L = les_successeurs(x);      while (!est_une_liste_vide(L))      {         y = tete(L);         cout << y << " " << nom_du_sommet[y] << endl;         fout << y << " " << nom_du_sommet[y] << endl;         entrer(y,F);         L = reste(L);              }   }  }// -------------------------- tri topologique (parcours en profondeur d'abord)void tri_topologique_recursif(SOMMET depart){   // chaque noeud ne doit etre affiche qu'une seule fois      // ENSEMBLE E = VIDE global      tri_topologique_liste(les_successeurs(depart));   if (!appartient(depart,E))   {      cout << depart << " " << nom_du_sommet[depart] << endl;      fout << depart << " " << nom_du_sommet[depart] << endl;      ajouter(depart,E);   }}void tri_topologique_liste(LISTE L){   if (!est_une_liste_vide(L))   {      tri_topologique_recursif(tete(L));      tri_topologique_liste(reste(L));   }}void tri_topologique_iteratif(SOMMET depart){   // chaque noeud ne doit etre affiche qu'une seule fois      PILE P;   ENSEMBLE E;   LISTE L;   BOOLEEN possible;   SOMMET x;      init_pile(P); empiler(depart,P);   init_ensemble(E); ajouter(depart,E);      while (!est_une_pile_vide(P))   {         // choisir, si c'est possible, un noeud qui soit,         // d'une part, successeur du noeud au sommet de la pile,         // et qui, d'autre part, n'appartienne pas         // a l'ensemble des noeuds deja affiches         // empiler ce noeud         // si ce n'est pas possible :         // depiler un noeud, l'afficher et l'ajouter a l'ensemble               possible = FAUX;      L = les_successeurs(sommet(P));      while (!est_une_liste_vide(L) && !possible)      {         x = tete(L);         if (!appartient(x,E))         {            empiler(x,P);            possible = VRAI;           }         else L = reste(L);      }      if (!possible)      {         depiler(x,P);         cout << x << " " << nom_du_sommet[x] << endl;         fout << x << " " << nom_du_sommet[x] << endl;         ajouter(x,E);      }   }}//=============================================================================//                                                       sommets.dat/*13maininitialisertraiteraffichersaisirselectionnerpermutertrierchoisirtestermodifiercomparerverifier*///=============================================================================//                                                        graphe.dat/*1 2 3 -14 -15 6 7 -1-1-18 9 10 -1-16 -111 -111 12 -1-1-1-1*///=============================================================================//                                                       affiche.dat/*parcours en profondeur recursif0 main1 initialiser4 saisir2 traiter5 selectionner8 choisir11 comparer9 tester11 comparer12 verifier10 modifier6 permuter7 trier6 permuter3 afficherparcours en profondeur iteratif0 main1 initialiser4 saisir2 traiter5 selectionner8 choisir11 comparer9 tester12 verifier10 modifier6 permuter7 trier3 afficherparcours en largeur0 main1 initialiser2 traiter3 afficher4 saisir5 selectionner6 permuter7 trier8 choisir9 tester10 modifier6 permuter11 comparer11 comparer12 verifiertri topologique recursif4 saisir1 initialiser11 comparer8 choisir12 verifier9 tester10 modifier5 selectionner6 permuter7 trier2 traiter3 afficher0 maintri topologique iteratif4 saisir1 initialiser11 comparer8 choisir12 verifier9 tester10 modifier5 selectionner6 permuter7 trier2 traiter3 afficher0 main*/